package transit;

import java.util.ArrayList;
//import algs4.LinkedStack;

/**
 * This class contains methods which perform various operations on a layered linked
 * list to simulate transit
 * 
 */
public class Transit {
	private TNode trainZero; // a reference to the zero node in the train layer

	/* 
	 * Default constructor used by the driver and Autolab. 
	 * DO NOT use in your code.
	 * DO NOT remove from this file
	 */ 
	public Transit() { trainZero = null; }

	/* 
	 * Default constructor used by the driver and Autolab. 
	 * DO NOT use in your code.
	 * DO NOT remove from this file
	 */
	public Transit(TNode tz) { trainZero = tz; }
	
	/*
	 * Getter method for trainZero
	 *
	 * DO NOT remove from this file.
	 */
	public TNode getTrainZero () {
		return trainZero;
	}

	/**
	 * Makes a layered linked list representing the given arrays of train stations, bus
	 * stops, and walking locations. Each layer begins with a location of 0, even though
	 * the arrays don't contain the value 0. Store the zero node in the train layer in
	 * the instance variable trainZero.
	 * 
	 * @param trainStations Int array listing all the train stations
	 * @param busStops Int array listing all the bus stops
	 * @param locations Int array listing all the walking locations (always increments by 1)
	 */
	public void makeList(int[] trainStations, int[] busStops, int[] locations) {

	    // UPDATE THIS METHOD
		//trainZero = TNode(0,       n,              d       );
		//trainZero = TNode(0, TNode(0, n, d), TNode(0, n, d));
		//TNode trainZeroW = new TNode(0, null, null);
		//TNode trainZeroB = new TNode(0, null, trainZeroW);
		trainZero = new TNode(0);

		// make three arrays of TNodes for train, bus, and walking
		TNode[] trains = new TNode[trainStations.length+1];
		TNode[] busses = new TNode[busStops.length+1];
		TNode[] walks = new TNode[locations.length+1];

		//go through it backwards, putting the last one as Null and establishing the order
		//establish the array element that is next as the current +1 with setnext() of that element
		
		//TNode n = new TNode();
		//trainZero.setNext(n);

/////////////////////////////////////////////////////////////////////////////////////////////////

		
		//locations, no downs
		for(int i = locations.length; i >= 0; i--){
			if (i == locations.length){
				walks[i] = new TNode(locations[i-1], null, null);
			}
			else{
				if(i==0){
					walks[i] = new TNode(0, walks[i+1], null);
				}
				else{
					walks[i] = new TNode(locations[i-1], walks[i+1], null);
				}
					
			}
		}

/////////////////////////////////////////////////////////////////////////////////////////////////
		//busses, the down should be locations (aka walks)
		for(int i = busStops.length; i >= 0; i--){
			if (i == busStops.length){
				for (TNode c:walks){
					if (c.getLocation() == busStops[i-1]){
						busses[i] = new TNode(busStops[i-1], null, c);
						//System.out.println("success " + busStops[i-1] + " " + c.getLocation());
						
						//System.out.println(busses[i].getDown() == c);
					}
					else{
						//busses[i] = new TNode(busStops[i-1], null, null);
						
					}
				}
			}
			else{
				if(i==0){
					busses[i] = new TNode(0, busses[i+1], walks[i]);
					//System.out.println("next is " + busses[i+1].getLocation() + " down is " + walks[i].getLocation());
				}
				else{
					//busses[i] = new TNode(busStops[i-1], busses[i+1], walks[i]);
					for (TNode c:walks){
						if (c.getLocation() == busStops[i-1]){
							busses[i] = new TNode(busStops[i-1], busses[i+1], c);
							//System.out.println(busses[i].getDown() == c);
							//System.out.println("next is " + busses[i+1].getLocation() + " down is " + c.getLocation());
						}
						else{
							//busses[i] = new TNode(busStops[i-1], busses[i+1], null);
						}
					}
					
				}
					
			}
			
		}

/////////////////////////////////////////////////////////////////////////////////////////////////
		//train stations, the down should be busses
		for(int i = trainStations.length; i >= 0; i--){
			if (i == trainStations.length){
				for (TNode c:busses){
					if (c.getLocation() == trainStations[i-1]){
					trains[i] = new TNode(trainStations[i-1], null, c);
					}
					else{
						//trains[i] = new TNode(trainStations[i-1], null, null);
					}
				}
				
			}
			
			else{
				if(i==0){
					//TNode j = busses[i];
					trains[i] = new TNode(0, trains[i+1], busses[i]);
					trains[i].setDown(busses[i]);
					trainZero = trains[i];
				}
				
				else{
					for (TNode c:busses){
						if (c.getLocation() == trainStations[i-1]){
						trains[i] = new TNode(trainStations[i-1], trains[i+1], c);
						}
						else{
							//trains[i] = new TNode(trainStations[i-1], trains[i+1], null);
						}
					}
				}
					
			}
		}

		
		
	}
	
	/**
	 * Modifies the layered list to remove the given train station but NOT its associated
	 * bus stop or walking location. Do nothing if the train station doesn't exist
	 * 
	 * @param station The location of the train station to remove
	 */
	public void removeTrainStation(int station) {
	    // UPDATE THIS METHOD
		//go through the .next of stations after the train station and set the matching
		//location station to null
		//TNode = TrainZero
		TNode trainZeroNext = trainZero;

		if (trainZeroNext.getLocation() == station){
			trainZeroNext.setNext(trainZeroNext.getNext().getNext());
			return;
		}

		while (trainZeroNext.getNext().getLocation() != station){
			if (trainZeroNext.getNext() == null){
				//System.out.println("Error!!!!");
				break;
			}
			trainZeroNext = trainZeroNext.getNext();
		}

		trainZeroNext.setNext(trainZeroNext.getNext().getNext());

	}

	/**
	 * Modifies the layered list to add a new bus stop at the specified location. Do nothing
	 * if there is no corresponding walking location.
	 * 
	 * @param busStop The location of the bus stop to add
	 */
	public void addBusStop(int busStop) {
	    // UPDATE THIS METHOD
		//the before next needs to be changed to the new busStop
		//the busStop itself needs to have the before next's busstop
		//iterate through the list finding a point where the next from the pointer
		//is greater than the busStop's location
		TNode busPointer = trainZero.getDown();
		while (busPointer.getNext().getLocation() < busStop){

			busPointer = busPointer.getNext();
		}

		TNode walkingPointer = trainZero.getDown().getDown();

		while (walkingPointer.getLocation() != busStop){
			walkingPointer = walkingPointer.getNext();
		}
		
		TNode changeNext = busPointer.getNext();
		TNode newBusStop = new TNode (busStop, changeNext, walkingPointer);
		busPointer.setNext(newBusStop);

	}
	
	/**
	 * Determines the optimal path to get to a given destination in the walking layer, and 
	 * collects all the nodes which are visited in this path into an arraylist. 
	 * 
	 * @param destination An int representing the destination
	 * @return
	 */
	public ArrayList<TNode> bestPath(int destination) {

	    // UPDATE THIS METHOD
		// trainZero is the beginning pointer
		TNode person = trainZero;
		//TNode bus = trainZero.getDown();
		//TNode walking = trainZero.getDown().getDown();
		ArrayList<TNode> bestPath = new ArrayList<TNode>();
		//go through train while it's below target, if person.getNext() is above then move down
		while (person.getNext().getLocation() <= destination){
			bestPath.add(person);
			person = person.getNext();
		}
		bestPath.add(person);
		if(person.getLocation() == destination) {return bestPath;}
		person = person.getDown();

		while(person.getNext().getLocation() <= destination){
			bestPath.add(person);
			person = person.getNext();
		}
		bestPath.add(person);
		if(person.getLocation() == destination) {return bestPath;}
		person = person.getDown();

		while(person.getNext().getLocation() <= destination){
			bestPath.add(person);
			person = person.getNext();
		}
		bestPath.add(person);
		if(person.getLocation() == destination) {return bestPath;}
		//System.out.println("ERROR");

	    return bestPath;
	}

	/**
	 * Returns a deep copy of the given layered list, which contains exactly the same
	 * locations and connections, but every node is a NEW node.
	 * 
	 * @return A reference to the train zero node of a deep copy
	 */
	public TNode duplicate() {

	    // UPDATE THIS METHOD
		//trainZero
		/*
		ArrayList <TNode> test = new ArrayList <TNode> ();
		test.add(trainZero);
		int a = test.size();
		*/


		TNode trainPtr = trainZero;
		//int trainC = 0;
		ArrayList <TNode> trainC = new ArrayList <TNode> ();
		int j = 0;
		while(trainPtr != null){
			TNode added = new TNode(j);
			j++;
			trainC.add(added);
			trainPtr = trainPtr.getNext();
		}

		TNode busPtr = trainZero.getDown();
		ArrayList <TNode> busC = new ArrayList <TNode> ();
		j = 0;
		while(busPtr != null){
			TNode added = new TNode(j);
			j++;
			busC.add(added);
			busPtr = busPtr.getNext();
		}

		TNode walkPtr = trainZero.getDown().getDown();
		ArrayList <TNode> walkC = new ArrayList <TNode> ();
		j = 0;
		while(walkPtr != null){
			TNode added = new TNode(j);
			j++;
			walkC.add(added);
			walkPtr = walkPtr.getNext();
		}

		trainPtr = trainZero;
		busPtr = trainZero.getDown();
		walkPtr = trainZero.getDown().getDown();
		
		
		for (int i = 0; i<walkC.size(); i++){
			walkC.get(i).setNext(walkPtr.getNext());
			walkC.get(i).setDown(null);
			if(walkPtr.getNext()==null){
				walkC.get(i).setNext(null);
				break;
			}
			walkC.get(i).setLocation(walkPtr.getLocation());
			walkPtr = walkPtr.getNext();
		}

		for (int i = 0; i<busC.size(); i++){
			busC.get(i).setNext(busPtr.getNext());
			busC.get(i).setDown(busPtr.getDown());
			if(busPtr.getNext()==null){
				busC.get(i).setNext(null);
				break;
			}
			busC.get(i).setLocation(busPtr.getLocation());
			busPtr = busPtr.getNext();
		}

		for (int i = 0; i<trainC.size(); i++){
			
			trainC.get(i).setDown(trainPtr.getDown());
			trainC.get(i).setLocation(trainPtr.getLocation());
			if(trainPtr.getNext()==null){
				trainC.get(i).setNext(null);
				break;
			}
			trainC.get(i).setNext(trainPtr.getNext());
			trainPtr = trainPtr.getNext();
		}
		

	    return trainC.get(0);
	}

	/**
	 * Modifies the given layered list to add a scooter layer in between the bus and
	 * walking layer.
	 * 
	 * @param scooterStops An int array representing where the scooter stops are located
	 */
	public void addScooter(int[] scooterStops) {

	    // UPDATE THIS METHOD
		TNode [] scooterStations = new TNode [scooterStops.length+1]; // +1 bc 0 node
		TNode busPtr = trainZero.getDown();
		TNode busPtr2 = trainZero.getDown();
		TNode walkPtr = trainZero.getDown().getDown();

		int k = 0;
		int lk = scooterStops[0];
		for(TNode c:scooterStations){ //make them all TNodes with locations
			if (k == 0) {lk = 0; k++;}
			else {lk = scooterStops[k-1]; k++;}
			scooterStations[k-1] = new TNode(lk);
		}
		//traverse through for three things:
		
		//scooter's nexts should be set in place
		k = 0;
		for (TNode c:scooterStations){
			if (k+1 < scooterStations.length){
				scooterStations[k].setNext(scooterStations[k+1]);
			}
			else{
				scooterStations[k].setNext(null);
			}
			k++;
		}

		//bus's downs should become scooters
			//go through bus from trainZero.getDown() and on until it's null
		TNode scooterPtr = scooterStations[0];
		while (busPtr != null){
			//k = 0;
			while (scooterPtr.getLocation() != busPtr.getLocation()){
				scooterPtr = scooterPtr.getNext();
			}
			busPtr.setDown(scooterPtr);
			busPtr = busPtr.getNext();
		}

		//scooter's downs should become walks
		
		TNode scooterPtr2 = scooterStations[0];
		while (scooterPtr2 != null){
			//k = 0;
			while (walkPtr.getLocation() != scooterPtr2.getLocation()){
				walkPtr = walkPtr.getNext();
			}
			scooterPtr2.setDown(walkPtr);
			scooterPtr2 = scooterPtr2.getNext();
		}

		
		
		
		
		
	}

	/**
	 * Used by the driver to display the layered linked list. 
	 * DO NOT edit.
	 */
	public void printList() {
		// Traverse the starts of the layers, then the layers within
		for (TNode vertPtr = trainZero; vertPtr != null; vertPtr = vertPtr.getDown()) {
			for (TNode horizPtr = vertPtr; horizPtr != null; horizPtr = horizPtr.getNext()) {
				// Output the location, then prepare for the arrow to the next
				StdOut.print(horizPtr.getLocation());
				if (horizPtr.getNext() == null) break;
				
				// Spacing is determined by the numbers in the walking layer
				for (int i = horizPtr.getLocation()+1; i < horizPtr.getNext().getLocation(); i++) {
					StdOut.print("--");
					int numLen = String.valueOf(i).length();
					for (int j = 0; j < numLen; j++) StdOut.print("-");
				}
				StdOut.print("->");
			}

			// Prepare for vertical lines
			if (vertPtr.getDown() == null) break;
			StdOut.println();
			
			TNode downPtr = vertPtr.getDown();
			// Reset horizPtr, and output a | under each number
			for (TNode horizPtr = vertPtr; horizPtr != null; horizPtr = horizPtr.getNext()) {
				while (downPtr.getLocation() < horizPtr.getLocation()) downPtr = downPtr.getNext();
				if (downPtr.getLocation() == horizPtr.getLocation() && horizPtr.getDown() == downPtr) StdOut.print("|");
				else StdOut.print(" ");
				int numLen = String.valueOf(horizPtr.getLocation()).length();
				for (int j = 0; j < numLen-1; j++) StdOut.print(" ");
				
				if (horizPtr.getNext() == null) break;
				
				for (int i = horizPtr.getLocation()+1; i <= horizPtr.getNext().getLocation(); i++) {
					StdOut.print("  ");

					if (i != horizPtr.getNext().getLocation()) {
						numLen = String.valueOf(i).length();
						for (int j = 0; j < numLen; j++) StdOut.print(" ");
					}
				}
			}
			StdOut.println();
		}
		StdOut.println();
	}
	
	/**
	 * Used by the driver to display best path. 
	 * DO NOT edit.
	 */
	public void printBestPath(int destination) {
		ArrayList<TNode> path = bestPath(destination);
		for (TNode vertPtr = trainZero; vertPtr != null; vertPtr = vertPtr.getDown()) {
			for (TNode horizPtr = vertPtr; horizPtr != null; horizPtr = horizPtr.getNext()) {
				// ONLY print the number if this node is in the path, otherwise spaces
				if (path.contains(horizPtr)) StdOut.print(horizPtr.getLocation());
				else {
					int numLen = String.valueOf(horizPtr.getLocation()).length();
					for (int i = 0; i < numLen; i++) StdOut.print(" ");
				}
				if (horizPtr.getNext() == null) break;
				
				// ONLY print the edge if both ends are in the path, otherwise spaces
				String separator = (path.contains(horizPtr) && path.contains(horizPtr.getNext())) ? ">" : " ";
				for (int i = horizPtr.getLocation()+1; i < horizPtr.getNext().getLocation(); i++) {
					StdOut.print(separator + separator);
					
					int numLen = String.valueOf(i).length();
					for (int j = 0; j < numLen; j++) StdOut.print(separator);
				}

				StdOut.print(separator + separator);
			}
			
			if (vertPtr.getDown() == null) break;
			StdOut.println();

			for (TNode horizPtr = vertPtr; horizPtr != null; horizPtr = horizPtr.getNext()) {
				// ONLY print the vertical edge if both ends are in the path, otherwise space
				StdOut.print((path.contains(horizPtr) && path.contains(horizPtr.getDown())) ? "V" : " ");
				int numLen = String.valueOf(horizPtr.getLocation()).length();
				for (int j = 0; j < numLen-1; j++) StdOut.print(" ");
				
				if (horizPtr.getNext() == null) break;
				
				for (int i = horizPtr.getLocation()+1; i <= horizPtr.getNext().getLocation(); i++) {
					StdOut.print("  ");

					if (i != horizPtr.getNext().getLocation()) {
						numLen = String.valueOf(i).length();
						for (int j = 0; j < numLen; j++) StdOut.print(" ");
					}
				}
			}
			StdOut.println();
		}
		StdOut.println();
	}
}
